unit MyThread;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface

uses Windows;

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////
type
  TThread = class(TObject)
  private
    FThrCallback: Pointer;
    FThrHandle  : THandle;
    FThrIdent   : DWord;
    function    ThreadCallback(Param: Pointer): DWord; stdcall;
  protected
    function    ThreadProcedure: DWord; virtual;
  public
    property    ThrHandle: THandle read FThrHandle;
    property    ThrIdent: DWord read FThrIdent;
  public
    constructor Create; virtual;
    destructor  Destroy; override;
  end;

implementation

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
constructor TThread.Create;
{$IFDEF FPC}
var
o : LongInt;
{$ENDIF}
begin
  inherited Create;
{$IFDEF FPC}
o := Ofs(TThread.ThreadCallback);
{$ENDIF}
  //      
  FThrCallback := VirtualAlloc(nil, 12, MEM_RESERVE OR MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  //    
  asm
    mov  EAX, Self
    mov  ECX, [EAX].TThread.FThrCallback
    mov  word  ptr [ECX+0], $6858               // pop  EAX
    mov  dword ptr [ECX+2], EAX                 // push _Self_
    mov  word  ptr [ECX+6], $E950               // push EAX
{$IFDEF FPC}
    mov  EAX, o
{$ELSE}
    mov  EAX, OFFSET(TThread.ThreadCallback)
{$ENDIF}
    sub  EAX, ECX
    sub  EAX, 12
    mov  dword ptr [ECX+8], EAX                 // jmp  TLiteThread.ThreadCallback
  end;
  //  
  FThrHandle := CreateThread(nil, 0, FThrCallback, nil, CREATE_SUSPENDED, FThrIdent);
end;

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
destructor TThread.Destroy;
begin
  //  
  CloseHandle(FThrHandle);
  //     
  VirtualFree(FThrCallback, 0, MEM_RELEASE);
  //   
  inherited;
end;

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
function TThread.ThreadCallback(Param: Pointer): DWord;
begin
  //    
  Result := ThreadProcedure;
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
function TThread.ThreadProcedure: DWord;
begin
  //   
  Result := 0;
end;

end.
