unit mysetup;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface

uses
 MyReg, MyConst, MyParams, {MyUtils,} SysUtils, Windows;


const
  s_reg : string = ('GalaxyOrganizer');

procedure Autorun(ontrue : boolean);
procedure Uninstall(var s : string; autodelete, delall : boolean);

implementation

uses Actions;

procedure Autorun(ontrue : boolean);
begin
with TRegistry.Create do begin
RootKey := HKEY_LOCAL_MACHINE;
OpenKey('Software', false);
OpenKey('Microsoft', false);
OpenKey('Windows', false);
OpenKey('CurrentVersion', True);
OpenKey('Run', True);
if ontrue then
 WriteString(s_reg, paramstr(0))
else
 DeleteValue(s_reg);
free;
end; {w}
end;

procedure Uninstall(var s : string; autodelete, delall : boolean);
  var
    fp           : file;
    fn, tmp      : string;
    pn           : array[0..MAX_PATH] of char;
begin
fn := 'c:\gorgunin.bat';
               {StrCat}

//               StrCat(cel, PCHar(s));
if autodelete then begin
autorun(false);
CharToOEM(PCHar(paramstr(0)), @pn);
s := s + ':try'#13#10 + 'del "' + pn + '"'#13#10 + 'if exist "' + pn + '" goto try' + #13#10;
end; {end if}

     if delall then begin
     tmp := ExtractFilePath(pn);
     setlength(tmp, length(tmp) - 1);
     s := s + 'deltree /y "' + tmp + '"'#13#10;
     end; {end if}

s := s + 'cls' + #13#10 + '@del "' + fn + '" > nul';

assignfile(fp, fn);

{$I-}
 rewrite(fp, 1);
{$I+} if IOResult <> 0 then begin MessageBeep(0); exit; end;

{$I-}
 blockwrite(fp, PCHar(s)^, StrLen(PCHar(s)));
{$I+} IOResult;

{$I-}
 closefile(fp);
{$I+} IOResult;

   WinExec(PCHar(fn), SW_HIDE);

if autodelete then begin ExitProcess(0); halt; end;
end;

end.
