unit cdialogs;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface
           uses windows, commdlg, messages, {myutils}sysutils, dbg;


type
      MyFileDlg = class(TObject)
      ta       : array[0..260] of char;
      FileName : string;
      p : TOpenFileName;
      protected

      private

      public
        function GetFileName(
        hwnd, happ     : THandle;
        Filter         : string;
        FilterIndex    : dword;    // 1..2..3
        DefExt         : string;
        InitialDir     : string;
        SaveTrue       : boolean;
        Title          : string
        ) : boolean;
      end;

implementation

function MyFileDlg.GetFileName;
begin p.hWndOwner             := hwnd; p.hInstance           := happ;

if filter = '' then p.lpstrFilter := nil
  else p.lpstrFilter := PCHar(filter); // 'Text'#0'*.TXT'#0'All'#0'*.*'#0 if nil then none
p.nFilterIndex       := FilterIndex;

p.lpstrCustomFilter  := nil; p.nMaxCustFilter     := 0;

ta[1] := #0;                 // nil if not need select init position
p.lpstrFile          := ta;  p.nMaxFile           := 260;
p.lpstrFileTitle     := nil; p.nMaxFileTitle      := 260;
if InitialDir = '' then p.lpstrInitialDir := nil else p.lpstrInitialDir    := PCHar(InitialDir); // nil - cur dir;
if Title = ''      then p.lpstrTitle      := nil else p.lpstrTitle := PCHar(Title);
p.Flags  :=
         OFN_FILEMUSTEXIST or
         OFN_EXPLORER or
         OFN_EXTENSIONDIFFERENT or
         OFN_HIDEREADONLY or
         OFN_NONETWORKBUTTON or
         OFN_OVERWRITEPROMPT;

p.nFileOffset        := 0;   p.nFileExtension     := 0;  // offset !!!

if DefExt = '' then p.lpstrDefExt  := nil else p.lpstrDefExt  := PCHar(DefExt); // 'txt' no .  !

p.lCustData          := 0;
p.lpfnHook           := nil;
p.lpTemplateName     := nil;
                     p.lStructSize := SizeOf(p);

if SaveTrue then result := GetSaveFileName({$IFDEF FPC}@{$ENDIF}p) else result := GetOpenFileName({$IFDEF FPC}@{$ENDIF}p);

  FileName := String(ta);
end;


end.
