unit winoff;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface

         uses windows, messages;

procedure GetRebootAccess(winnt : boolean);
function  WindowsNT : boolean;
procedure EndWindowsF(winnt, offtrue, forcetrue, pwroff : boolean);

implementation

procedure GetRebootAccess(winnt : boolean);
const
 SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';// Borland forgot this declaration
  var
   action       : longint;
   hToken       : THandle;
   tkp          : TTokenPrivileges;
   tkpo         : TTokenPrivileges;
   zero         : DWORD;
begin
if winnt then begin
 zero := 0;
 if not OpenProcessToken( GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
 begin
  MessageBox( 0, 'Exit Error', 'OpenProcessToken() Failed', MB_OK );
  Exit;
 end; // if not OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken)
  if not OpenProcessToken( GetCurrentProcess(),
  TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
  begin
   MessageBox( 0, 'Exit Error', 'OpenProcessToken() Failed', MB_OK );
   Exit;
  end; // if not OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken)
  // SE_SHUTDOWN_NAME
  if not LookupPrivilegeValue( nil, 'SeShutdownPrivilege' ,
  tkp.Privileges[ 0 ].Luid ) then
  begin
   MessageBox( 0, 'Exit Error', 'LookupPrivilegeValue() Failed', MB_OK );
   Exit;
  end; //  if not LookupPrivilegeValue( nil, 'SeShutdownPrivilege' , tkp.Privileges[0].Luid )
  tkp.PrivilegeCount := 1;
  tkp.Privileges[ 0 ].Attributes := SE_PRIVILEGE_ENABLED;
  AdjustTokenPrivileges( hToken, False, tkp, SizeOf(
  TTokenPrivileges ), tkpo, zero );
    if Boolean( GetLastError() ) then
      begin
      MessageBox( 0, 'Exit Error', 'AdjustTokenPrivileges() Failed', MB_OK );
      Exit;
      end;
end; {if nt}
end;

function WindowsNT : boolean;
  var
    ver: TOSVERSIONINFO;
begin
ver.dwOSVersionInfoSize := Sizeof(ver);
GetVersionEx(ver);
result := ver.dwPlatformId = VER_PLATFORM_WIN32_NT;
end;

procedure EndWindowsF(winnt, offtrue, forcetrue, pwroff : boolean);
const
 C_REBOOT : longint = 2; C_POWEROFF : longint = 8;
 C_SHUTDOWN : longint = 1; C_LOGOFF : longint = 0;
 C_FORCE : longint = 4;
  var
   action       : longint;
begin
if forcetrue then action := action or C_FORCE;

if offtrue then begin
 action := C_SHUTDOWN;
 if pwroff then action := action or C_POWEROFF;
end
else action := C_REBOOT;

if not ExitWindowsEx(action, 0) then MessageBeep(0);
end;

end.
